diff -u -r linux.clean/drivers/scsi/sd.c linux.new2/drivers/scsi/sd.c
--- linux.clean/drivers/scsi/sd.c	Wed Jul 28 18:24:34 1999
+++ linux.new2/drivers/scsi/sd.c	Wed Jul 28 19:45:36 1999
@@ -1,6 +1,6 @@
 /*
  *      sd.c Copyright (C) 1992 Drew Eckhardt
- *           Copyright (C) 1993, 1994, 1995 Eric Youngdale
+ *           Copyright (C) 1993, 1994, 1995, 1999 Eric Youngdale
  *
  *      Linux scsi disk driver
  *              Initial versions: Drew Eckhardt
@@ -8,11 +8,11 @@
  *
  *      <drew@colorado.edu>
  *
- *       Modified by Eric Youngdale ericy@cais.com to
+ *       Modified by Eric Youngdale ericy@andante.org to
  *       add scatter-gather, multiple outstanding request, and other
  *       enhancements.
  *
- *       Modified by Eric Youngdale eric@aib.com to support loadable
+ *       Modified by Eric Youngdale eric@andante.org to support loadable
  *       low-level scsi drivers.
  *
  *       Modified by Jirka Hanika geo@ff.cuni.cz to support more
@@ -94,13 +94,20 @@
 
 static int sd_init_onedisk(int);
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
 static void requeue_sd_request (Scsi_Cmnd * SCpnt);
+#endif
 
 static int sd_init(void);
 static void sd_finish(void);
 static int sd_attach(Scsi_Device *);
 static int sd_detect(Scsi_Device *);
 static void sd_detach(Scsi_Device *);
+static void rw_intr (Scsi_Cmnd *SCpnt);
+
+#ifdef CONFIG_SCSI_NEW_QUEUES
+static int sd_init_command(Scsi_Cmnd *);
+#endif
 
 static void sd_devname(unsigned int disknum, char * buffer)
 {
@@ -120,12 +127,193 @@
 }
 
 struct Scsi_Device_Template sd_template =
-{ NULL, "disk", "sd", NULL, TYPE_DISK,
-      SCSI_DISK0_MAJOR, 0, 0, 0, 1,
-      sd_detect, sd_init,
-      sd_finish, sd_attach, sd_detach
+{
+    name:         "disk",
+    tag:          "sd", 
+    scsi_type:    TYPE_DISK,
+    major:        SCSI_DISK0_MAJOR, 
+    blk:          1,
+    detect:       sd_detect, 
+    init:         sd_init,
+    finish:       sd_finish, 
+    attach:       sd_attach, 
+    detach:       sd_detach,
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    init_command: sd_init_command,
+#endif
 };
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+static request_queue_t * sd_find_queue(kdev_t dev)
+{
+     Scsi_Disk       * dpnt;
+    int target;
+    target =  DEVICE_NR(dev);
+
+    dpnt = &rscsi_disks[target];
+    if(!dpnt)
+	return NULL;   /* No such device */
+    return &dpnt->device->request_queue;
+}
+
+static int sd_init_command(Scsi_Cmnd * SCpnt)
+{
+    int dev, devm, block, this_count;
+    Scsi_Disk           * dpnt;
+    char nbuff[6];
+
+    devm =  MINOR(SCpnt->request.rq_dev);
+    dev = DEVICE_NR(SCpnt->request.rq_dev);
+
+    block = SCpnt->request.sector;
+    this_count = SCpnt->request_bufflen >> 9;
+
+    SCSI_LOG_HLQUEUE(1,printk("Doing sd request, dev = %d, block = %d\n", devm, block));
+
+    dpnt = &rscsi_disks[dev];
+    if (devm >= (sd_template.dev_max << 4) ||
+        !dpnt || 
+	!dpnt->device->online ||
+	block + SCpnt->request.nr_sectors > sd[devm].nr_sects)
+    {
+        SCSI_LOG_HLQUEUE(2,printk("Finishing %ld sectors\n", SCpnt->request.nr_sectors));
+	SCpnt = scsi_end_request(SCpnt, 0, SCpnt->request.nr_sectors);
+        SCSI_LOG_HLQUEUE(2,printk("Retry with 0x%p\n", SCpnt));
+        return 0;
+    }
+
+    block += sd[devm].start_sect;
+    if (dpnt->device->changed)
+    {
+	/*
+	 * quietly refuse to do anything to a changed disc until the changed
+	 * bit has been reset
+	 */
+	/* printk("SCSI disk has been changed. Prohibiting further I/O.\n"); */
+	SCpnt = scsi_end_request(SCpnt, 0, SCpnt->request.nr_sectors);
+        return 0;
+    }
+
+    SCSI_LOG_HLQUEUE(2,sd_devname(devm, nbuff));
+    SCSI_LOG_HLQUEUE(2,printk("%s : real dev = /dev/%d, block = %d\n",
+	   nbuff, dev, block));
+
+    /*
+     * If we have a 1K hardware sectorsize, prevent access to single
+     * 512 byte sectors.  In theory we could handle this - in fact
+     * the scsi cdrom driver must be able to handle this because
+     * we typically use 1K blocksizes, and cdroms typically have
+     * 2K hardware sectorsizes.  Of course, things are simpler
+     * with the cdrom, since it is read-only.  For performance
+     * reasons, the filesystems should be able to handle this
+     * and not force the scsi disk driver to use bounce buffers
+     * for this.
+     */
+    if (dpnt->device->sector_size == 1024)
+    {
+	if((block & 1) || (SCpnt->request.nr_sectors & 1)) 
+        {
+	    printk("sd.c:Bad block number requested");
+	    SCpnt = scsi_end_request(SCpnt, 0, SCpnt->request.nr_sectors);
+	    return 0;
+	}
+        else
+        {
+            block = block >> 1;
+            this_count = this_count >> 1;
+        }
+    }
+
+     if (dpnt->device->sector_size == 2048)
+     {
+         if((block & 3) || (SCpnt->request.nr_sectors & 3)) 
+         {
+             printk("sd.c:Bad block number requested");
+             SCpnt = scsi_end_request(SCpnt, 0, SCpnt->request.nr_sectors);
+             return 0;
+         }
+         else
+         {
+             block = block >> 2;
+             this_count = this_count >> 2;
+         }
+     }
+    switch (SCpnt->request.cmd)
+    {
+    case WRITE :
+	if (!dpnt->device->writeable)
+	{
+	    SCpnt = scsi_end_request(SCpnt, 0, SCpnt->request.nr_sectors);
+            return 0;
+	}
+	SCpnt->cmnd[0] = WRITE_6;
+	break;
+    case READ :
+	SCpnt->cmnd[0] = READ_6;
+	break;
+    default :
+	panic ("Unknown sd command %d\n", SCpnt->request.cmd);
+    }
+
+    SCSI_LOG_HLQUEUE(2,printk("%s : %s %d/%ld 512 byte blocks.\n",
+                              nbuff,
+                              (SCpnt->request.cmd == WRITE) ? "writing" : "reading",
+                              this_count, SCpnt->request.nr_sectors));
+
+    SCpnt->cmnd[1] = (SCpnt->lun << 5) & 0xe0;
+     
+    if (((this_count > 0xff) ||  (block > 0x1fffff)) && SCpnt->device->ten)
+    {
+	if (this_count > 0xffff)
+	    this_count = 0xffff;
+
+	SCpnt->cmnd[0] += READ_10 - READ_6 ;
+	SCpnt->cmnd[2] = (unsigned char) (block >> 24) & 0xff;
+	SCpnt->cmnd[3] = (unsigned char) (block >> 16) & 0xff;
+	SCpnt->cmnd[4] = (unsigned char) (block >> 8) & 0xff;
+	SCpnt->cmnd[5] = (unsigned char) block & 0xff;
+	SCpnt->cmnd[6] = SCpnt->cmnd[9] = 0;
+	SCpnt->cmnd[7] = (unsigned char) (this_count >> 8) & 0xff;
+	SCpnt->cmnd[8] = (unsigned char) this_count & 0xff;
+    }
+    else
+    {
+	if (this_count > 0xff)
+	    this_count = 0xff;
+
+	SCpnt->cmnd[1] |= (unsigned char) ((block >> 16) & 0x1f);
+	SCpnt->cmnd[2] = (unsigned char) ((block >> 8) & 0xff);
+	SCpnt->cmnd[3] = (unsigned char) block & 0xff;
+	SCpnt->cmnd[4] = (unsigned char) this_count;
+	SCpnt->cmnd[5] = 0;
+    }
+
+    /*
+     * We shouldn't disconnect in the middle of a sector, so with a dumb
+     * host adapter, it's safe to assume that we can at least transfer
+     * this many bytes between each connect / disconnect.
+     */
+    SCpnt->transfersize = dpnt->device->sector_size;
+    SCpnt->underflow = this_count << 9;
+    
+    SCpnt->allowed = MAX_RETRIES;
+    SCpnt->timeout_per_command = (SCpnt->device->type == TYPE_DISK ?
+		  SD_TIMEOUT : SD_MOD_TIMEOUT);
+
+    /*
+     * This is the completion routine we use.  This is matched in terms
+     * of capability to this function.
+     */
+    SCpnt->done = rw_intr;
+
+    /*
+     * This indicates that the command is ready from our end to be
+     * queued.
+     */
+    return 1;
+}
+#endif
+
 static int sd_open(struct inode * inode, struct file * filp)
 {
     int target;
@@ -287,7 +475,7 @@
     int good_sectors = (result == 0 ? this_count : 0);
     int block_sectors = 1;
 
-    sd_devname(DEVICE_NR(SCpnt->request.rq_dev), nbuff);
+    SCSI_LOG_HLCOMPLETE(1,sd_devname(DEVICE_NR(SCpnt->request.rq_dev), nbuff));
 
     SCSI_LOG_HLCOMPLETE(1,printk("%s : rw_intr(%d, %x [%x %x])\n", nbuff,
 	   SCpnt->host->host_no, 
@@ -300,6 +488,47 @@
       relatively rare error condition, no care is taken to avoid unnecessary
       additional work such as memcpy's that could be avoided.
     */
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    if (driver_byte(result) != 0 &&		    /* An error occurred */
+	SCpnt->sense_buffer[0] == 0xF0 &&	    /* Sense data is valid */
+	SCpnt->sense_buffer[2] == MEDIUM_ERROR)
+    {
+	long error_sector = (SCpnt->sense_buffer[3] << 24) |
+			    (SCpnt->sense_buffer[4] << 16) |
+			    (SCpnt->sense_buffer[5] << 8) |
+			    SCpnt->sense_buffer[6];
+	if (SCpnt->request.bh != NULL)
+            block_sectors = SCpnt->request.bh->b_size >> 9;
+        switch(SCpnt->device->sector_size)
+        {
+        case 1024:
+	    error_sector <<= 1;
+	    if (block_sectors < 2) block_sectors = 2;
+            break;
+        case 2048:
+	    error_sector <<= 2;
+	    if (block_sectors < 4) block_sectors = 4;
+            break;
+        case 256:
+            error_sector >>= 1;
+            break;
+        default:
+            break;
+        }
+	error_sector -= sd[MINOR(SCpnt->request.rq_dev)].start_sect;
+	error_sector &= ~ (block_sectors - 1);
+	good_sectors = error_sector - SCpnt->request.sector;
+	if (good_sectors < 0 || good_sectors >= this_count)
+	  good_sectors = 0;
+    }
+
+    /*
+     * This calls the generic completion function, now that we know
+     * how many actual sectors finished, and how many sectors we need
+     * to say have failed.
+     */
+    scsi_io_completion(SCpnt, good_sectors, block_sectors);
+#else
 
     if (driver_byte(result) != 0 &&		    /* An error occurred */
 	SCpnt->sense_buffer[0] == 0xF0 &&	    /* Sense data is valid */
@@ -519,6 +748,7 @@
 	requeue_sd_request(SCpnt);
 	return;
     }
+#endif
 }
 
 /*
@@ -527,7 +757,8 @@
  * them to SCSI commands.
  */
 
-static void do_sd_request (void)
+#ifndef CONFIG_SCSI_NEW_QUEUES
+static void do_sd_request (request_queue_t * q)
 {
     Scsi_Cmnd * SCpnt = NULL;
     Scsi_Device * SDev;
@@ -535,7 +766,7 @@
     int flag = 0;
 
     while (1==1){
-	if (CURRENT != NULL && CURRENT->rq_status == RQ_INACTIVE) {
+	if (CURRENT != NULL && q->plugged) {
 	    return;
 	}
 
@@ -627,6 +858,9 @@
 		req1 = req;
 		req = req->next;
 	    }
+            /*
+             * WTF???   Why are we interested in requests that are inactive?
+             */
 	    if (SCpnt && req->rq_status == RQ_INACTIVE) {
 		if (req == CURRENT)
 		    CURRENT = CURRENT->next;
@@ -655,7 +889,7 @@
  repeat:
 
     if(!SCpnt || SCpnt->request.rq_status == RQ_INACTIVE) {
-	do_sd_request();
+	do_sd_request(NULL);
 	return;
     }
 
@@ -1058,6 +1292,7 @@
 		  SD_TIMEOUT : SD_MOD_TIMEOUT),
 		 MAX_RETRIES);
 }
+#endif
 
 static int check_scsidisk_media_change(kdev_t full_dev){
     int retval;
@@ -1141,6 +1376,7 @@
     char          nbuff[6];
     unsigned char *buffer;
     unsigned long spintime;
+    int sector_size;
     int the_result, retries;
     Scsi_Cmnd * SCpnt;
 
@@ -1158,14 +1394,21 @@
         return i;
     }
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_lock_irq(&io_request_lock);
+#endif
 
     /* We need to retry the READ_CAPACITY because a UNIT_ATTENTION is
      * considered a fatal error, and many devices report such an error
      * just after a scsi bus reset.
      */
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    SCpnt = scsi_allocate_device(rscsi_disks[i].device, 1);
+#else
     SCpnt = scsi_allocate_device(NULL, rscsi_disks[i].device, 1);
+#endif
+
     buffer = (unsigned char *) scsi_malloc(512);
 
     spintime = 0;
@@ -1192,9 +1435,13 @@
 				 (void *) cmd, (void *) buffer,
 				 512, sd_init_done,  SD_TIMEOUT,
 				 MAX_RETRIES);
+#ifndef CONFIG_SCSI_NEW_QUEUES
 		    spin_unlock_irq(&io_request_lock);
+#endif
 		    down(&sem);
+#ifndef CONFIG_SCSI_NEW_QUEUES
 		    spin_lock_irq(&io_request_lock);
+#endif
                     SCpnt->request.sem = NULL;
 		}
 
@@ -1230,9 +1477,13 @@
 				     (void *) cmd, (void *) buffer,
 				     512, sd_init_done,  SD_TIMEOUT,
 				     MAX_RETRIES);
+#ifndef CONFIG_SCSI_NEW_QUEUES
 			spin_unlock_irq(&io_request_lock);
+#endif
 			down(&sem);
+#ifndef CONFIG_SCSI_NEW_QUEUES
 			spin_lock_irq(&io_request_lock);
+#endif
                         SCpnt->request.sem = NULL;
 		    }
 
@@ -1240,10 +1491,14 @@
 		}
 
 		time1 = jiffies + HZ;
+#ifndef CONFIG_SCSI_NEW_QUEUES
 		spin_unlock_irq(&io_request_lock);
+#endif
 		while(jiffies < time1); /* Wait 1 second for next try */
 		printk( "." );
+#ifndef CONFIG_SCSI_NEW_QUEUES
 		spin_lock_irq(&io_request_lock);
+#endif
 	    }
 	} while(the_result && spintime && spintime+100*HZ > jiffies);
 	if (spintime) {
@@ -1272,9 +1527,13 @@
 			 (void *) cmd, (void *) buffer,
 			 8, sd_init_done,  SD_TIMEOUT,
 			 MAX_RETRIES);
+#ifndef CONFIG_SCSI_NEW_QUEUES
 	    spin_unlock_irq(&io_request_lock);
+#endif
 	    down(&sem);	/* sleep until it is ready */
+#ifndef CONFIG_SCSI_NEW_QUEUES
 	    spin_lock_irq(&io_request_lock);
+#endif
             SCpnt->request.sem = NULL;
 	}
 
@@ -1316,7 +1575,7 @@
 	printk("%s : block size assumed to be 512 bytes, disk size 1GB.  \n",
 	       nbuff);
 	rscsi_disks[i].capacity = 0x1fffff;
-	rscsi_disks[i].sector_size = 512;
+	sector_size = 512;
 
 	/* Set dirty bit for removable devices if not ready - sometimes drives
 	 * will not report this properly. */
@@ -1337,23 +1596,32 @@
 				       (buffer[2] << 8) |
 				       buffer[3]);
 
-	rscsi_disks[i].sector_size = (buffer[4] << 24) |
+	sector_size = (buffer[4] << 24) |
 	    (buffer[5] << 16) | (buffer[6] << 8) | buffer[7];
 
-	if (rscsi_disks[i].sector_size == 0) {
-	  rscsi_disks[i].sector_size = 512;
+	if (sector_size == 0) {
+	  sector_size = 512;
 	  printk("%s : sector size 0 reported, assuming 512.\n", nbuff);
 	}
 
 
-	if (rscsi_disks[i].sector_size != 512 &&
-	    rscsi_disks[i].sector_size != 1024 &&
-	    rscsi_disks[i].sector_size != 2048 &&
-	    rscsi_disks[i].sector_size != 4096 &&
-	    rscsi_disks[i].sector_size != 256)
+	if (sector_size != 512 &&
+	    sector_size != 1024 &&
+	    sector_size != 2048 &&
+	    sector_size != 4096 &&
+	    sector_size != 256)
 	{
 	    printk ("%s : unsupported sector size %d.\n",
-		    nbuff, rscsi_disks[i].sector_size);
+		    nbuff, sector_size);
+#ifdef CONFIG_SCSI_NEW_QUEUES
+            /*
+             * The user might want to re-format the drive with
+             * a supported sectorsize.  Once this happens, it
+             * would be relatively trivial to set the thing up.
+             * For this reason, we leave the thing in the table.
+             */
+            rscsi_disks[i].capacity = 0;
+#else
 	    if(rscsi_disks[i].device->removable){
 		rscsi_disks[i].capacity = 0;
 	    } else {
@@ -1369,9 +1637,10 @@
                 
 		return i;
 	    }
+#endif
 	}
 
-        if( rscsi_disks[i].sector_size == 2048 )
+        if( sector_size == 2048 )
           {
             int m;
 
@@ -1394,7 +1663,7 @@
 	 */
 	int m, mb;
         int sz_quot, sz_rem;
-	int hard_sector = rscsi_disks[i].sector_size;
+	int hard_sector = sector_size;
 	/* There are 16 minors allocated for each major device */
 	for (m=i<<4; m<((i+1)<<4); m++){
 	    sd_hardsizes[m] = hard_sector;
@@ -1409,13 +1678,13 @@
 		nbuff, hard_sector, rscsi_disks[i].capacity,
                 mb, sz_quot, sz_rem);
     }
-	if(rscsi_disks[i].sector_size == 4096)
+	if(sector_size == 4096)
 	    rscsi_disks[i].capacity <<= 3;
-	if(rscsi_disks[i].sector_size == 2048)
+	if(sector_size == 2048)
 	    rscsi_disks[i].capacity <<= 2;  /* Change into 512 byte sectors */
-	if(rscsi_disks[i].sector_size == 1024)
+	if(sector_size == 1024)
 	    rscsi_disks[i].capacity <<= 1;  /* Change into 512 byte sectors */
-	if(rscsi_disks[i].sector_size == 256)
+	if(sector_size == 256)
 	    rscsi_disks[i].capacity >>= 1;  /* Change into 512 byte sectors */
     }
 
@@ -1452,9 +1721,13 @@
 			 (void *) cmd, (void *) buffer,
 			 512, sd_init_done,  SD_TIMEOUT,
 			 MAX_RETRIES);
+#ifndef CONFIG_SCSI_NEW_QUEUES
 	    spin_unlock_irq(&io_request_lock);
+#endif
 	    down(&sem);
+#ifndef CONFIG_SCSI_NEW_QUEUES
 	    spin_lock_irq(&io_request_lock);
+#endif
             SCpnt->request.sem = NULL;
 	}
 
@@ -1471,15 +1744,25 @@
 
     }	/* check for write protect */
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    SCpnt->device->ten   = 1;
+    SCpnt->device->remap = 1;
+    SCpnt->device->sector_size = sector_size;
+#else
+    rscsi_disks[i].ten = 1;
+    rscsi_disks[i].remap = 1;
+    rscsi_disks[i].sector_size = sector_size;
+#endif
+
     /* Wake up a process waiting for device */
     wake_up(&SCpnt->device->device_wait);
     scsi_release_command(SCpnt);
     SCpnt = NULL;
 
-    rscsi_disks[i].ten = 1;
-    rscsi_disks[i].remap = 1;
     scsi_free(buffer, 512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_unlock_irq(&io_request_lock);
+#endif
     return i;
 }
 
@@ -1563,23 +1846,30 @@
     return 0;
 }
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
 /*
  * sd_get_queue() returns the queue which corresponds to a given device.
  */
-static struct request **sd_get_queue (kdev_t dev)
+static request_queue_t *sd_get_queue (kdev_t dev)
 {
-	return &blk_dev[MAJOR_NR].current_request;
+	return &blk_dev[MAJOR_NR].request_queue;
 }
+#endif
 
 static void sd_finish()
 {
     struct gendisk *gendisk;
     int i;
 
-    for (i=0; i <= (sd_template.dev_max - 1) / SCSI_DISKS_PER_MAJOR; i++) {
-        /* FIXME: After 2.2 we should implement multiple sd queues */
-        blk_dev[SD_MAJOR(i)].request_fn = DEVICE_REQUEST;
+    for (i=0; i <= (sd_template.dev_max - 1) / SCSI_DISKS_PER_MAJOR; i++) 
+    {
+#ifdef CONFIG_SCSI_NEW_QUEUES
+        blk_dev[SD_MAJOR(i)].queue = sd_find_queue;
+#else
+        blk_init_queue(BLK_DEFAULT_QUEUE(SD_MAJOR(i)), DEVICE_REQUEST);
+        blk_queue_headactive(BLK_DEFAULT_QUEUE(MAJOR_NR), 0);
         if (i) blk_dev[SD_MAJOR(i)].queue = sd_get_queue;
+#endif
     }
 
     for (gendisk = gendisk_head; gendisk != NULL; gendisk = gendisk->next)
@@ -1651,7 +1941,9 @@
 
     if(i >= sd_template.dev_max) panic ("scsi_devices corrupt (sd)");
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
     SDp->scsi_request_fn = do_sd_request;
+#endif
     rscsi_disks[i].device = SDp;
     rscsi_disks[i].has_part_table = 0;
     sd_template.nr_dev++;
@@ -1704,7 +1996,11 @@
          * to make sure that everything remains consistent.
          */
         sd_blocksizes[index] = 1024;
+#ifdef CONFIG_SCSI_NEW_QUEUES
+        if( rscsi_disks[target].device->sector_size == 2048 )
+#else
         if( rscsi_disks[target].sector_size == 2048 )
+#endif
           sd_blocksizes[index] = 2048;
         else
           sd_blocksizes[index] = 1024;
@@ -1816,7 +2112,7 @@
     }
 
     for (i=0; i <= (sd_template.dev_max - 1) / SCSI_DISKS_PER_MAJOR; i++) {
-        blk_dev[SD_MAJOR(i)].request_fn = NULL;
+        blk_cleanup_queue(BLK_DEFAULT_QUEUE(SD_MAJOR(i)));
         blk_size[SD_MAJOR(i)] = NULL;
         hardsect_size[SD_MAJOR(i)] = NULL;
         read_ahead[SD_MAJOR(i)] = 0;
diff -u -r linux.clean/drivers/scsi/sd.h linux.new2/drivers/scsi/sd.h
--- linux.clean/drivers/scsi/sd.h	Mon Sep  6 09:03:52 1999
+++ linux.new2/drivers/scsi/sd.h	Mon Sep  6 09:03:14 1999
@@ -5,7 +5,7 @@
  *
  *	<drew@colorado.edu>
  *
- *	 Modified by Eric Youngdale eric@aib.com to
+ *	 Modified by Eric Youngdale eric@andante.org to
  *	 add scatter-gather, multiple outstanding request, and other
  *	 enhancements.
  */
@@ -27,14 +27,18 @@
 
 typedef struct scsi_disk {
     unsigned capacity;		    /* size in blocks */
+#ifndef CONFIG_SCSI_NEW_QUEUES
     unsigned sector_size;	    /* size in bytes */
+#endif
     Scsi_Device	 *device;	    
     unsigned char ready;	    /* flag ready for FLOPTICAL */
     unsigned char write_prot;	    /* flag write_protect for rmvable dev */
     unsigned char sector_bit_size;  /* sector_size = 2 to the  bit size power */
     unsigned char sector_bit_shift; /* power of 2 sectors per FS block */
+#ifndef CONFIG_SCSI_NEW_QUEUES
     unsigned ten:1;		    /* support ten byte read / write */
     unsigned remap:1;		    /* support remapping  */
+#endif
     unsigned has_part_table:1;	    /* has partition table */
 } Scsi_Disk;
 
diff -u -r linux.clean/drivers/scsi/sg.c linux.new2/drivers/scsi/sg.c
--- linux.clean/drivers/scsi/sg.c	Mon Jun  7 19:26:25 1999
+++ linux.new2/drivers/scsi/sg.c	Wed Jul 28 19:22:40 1999
@@ -366,7 +366,9 @@
 static ssize_t sg_write(struct file * filp, const char * buf, 
                         size_t count, loff_t *ppos)
 {
+#ifndef CONFIG_SCSI_NEW_QUEUES
     unsigned long         flags;
+#endif
     int                   mxsize, cmd_size, k;
     unsigned char         cmnd[MAX_COMMAND_SIZE];
     int                   input_size;
@@ -432,8 +434,14 @@
         return k;    /* probably out of space --> ENOMEM */
     }
 /*  SCSI_LOG_TIMEOUT(7, printk("sg_write: allocating device\n")); */
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    if (! (SCpnt = scsi_allocate_device(sdp->device, 
+                                        !(filp->f_flags & O_NONBLOCK)))) 
+#else
     if (! (SCpnt = scsi_allocate_device(NULL, sdp->device, 
-                                        !(filp->f_flags & O_NONBLOCK)))) {
+                                        !(filp->f_flags & O_NONBLOCK)))) 
+#endif
+    {
         sg_finish_rem_req(srp, NULL, 0);
         return -EAGAIN;   /* No available command blocks at the moment */
     }
@@ -448,7 +456,9 @@
     cmnd[1]= (cmnd[1] & 0x1f) | (sdp->device->lun << 5);
 
 /*  SCSI_LOG_TIMEOUT(7, printk("sg_write: do cmd\n")); */
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_lock_irqsave(&io_request_lock, flags);
+#endif
     SCpnt->use_sg = srp->data.use_sg;
     SCpnt->sglist_len = srp->data.sglist_len;
     SCpnt->bufflen = srp->data.bufflen;
@@ -467,7 +477,9 @@
                 (void *)SCpnt->buffer, mxsize,
                 sg_command_done, sfp->timeout, SG_DEFAULT_RETRIES);
     /* 'mxsize' overwrites SCpnt->bufflen, hence need for b_malloc_len */
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 /*  SCSI_LOG_TIMEOUT(6, printk("sg_write: sent scsi cmd to mid-level\n")); */
     return count;
 }
@@ -1099,7 +1111,13 @@
         scsi_add_timer(scpnt, scpnt->timeout_per_command,
                        scsi_old_times_out);
 #else
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    spin_unlock_irq(&io_request_lock);
+#endif
     scsi_sleep(HZ); /* just sleep 1 second and hope ... */
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    spin_lock_irq(&io_request_lock);
+#endif
 #endif
 }
 
